* [PATCH V2] xfstests: add fsstress/recovery test for XFS
@ 2013-09-02 11:46 Dave Chinner
2013-10-30 4:02 ` Dave Chinner
0 siblings, 1 reply; 2+ messages in thread
From: Dave Chinner @ 2013-09-02 11:46 UTC (permalink / raw)
To: xfs
From: Dave Chinner <dchinner@redhat.com>
This has found several issues with recovery on CRC based
filesystems. It is based on a test case for a dir3 assert failure
provided by Michael L Semon.
The test seems to pass now fine with or without CRCs enabled with
all the kernel patches I've posted over the past day.
Signed-off-by: Dave Chinner <dchinner@redhat.com>
---
tests/xfs/300 | 105 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
tests/xfs/300.out | 2 ++
tests/xfs/group | 1 +
3 files changed, 108 insertions(+)
create mode 100644 tests/xfs/300
create mode 100644 tests/xfs/300.out
diff --git a/tests/xfs/300 b/tests/xfs/300
new file mode 100644
index 0000000..38ecd65
--- /dev/null
+++ b/tests/xfs/300
@@ -0,0 +1,105 @@
+#!/bin/bash
+# FS QA Test No. xfs/300
+#
+# Basic log recovery stress test - do lots of stuff, shut down in the middle of
+# it and check that recovery runs to completion and everything can be
+# successfully removed afterwards..
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Red Hat, Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+_cleanup()
+{
+ cd /
+ umount $SCRATCH_MNT 2>/dev/null
+ rm -f $tmp.*
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# real QA test starts here
+_supported_fs xfs
+_supported_os Linux
+
+_require_scratch
+
+rm -f $seqres.full
+
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount
+
+SLEEP_TIME=$((30 * $TIME_FACTOR))
+PROCS=$((2 * LOAD_FACTOR))
+
+load_dir=$SCRATCH_MNT/test
+
+# let this run for a while
+$FSSTRESS_PROG -n10000000 -p $PROCS -d $load_dir >> $seqres.full 2>&1 &
+sleep $SLEEP_TIME
+killall -q $FSSTRESS_PROG
+wait
+sync
+umount $SCRATCH_MNT
+
+# now mount again, run the load again, this time with a shutdown.
+_scratch_mount
+$XFS_FSR_PROG -v $load_dir >> $seqres.full 2>&1
+$FSSTRESS_PROG -n10000000 -p $PROCS -d $load_dir >> $seqres.full 2>&1 &
+sleep $SLEEP_TIME
+sync
+
+# now shutdown and unmount
+sleep 5
+$here/src/godown $load_dir
+killall -q $FSSTRESS_PROG
+wait
+
+# for some reason fsstress processes manage to live on beyond the wait?
+sleep 5
+umount $SCRATCH_MNT
+
+# now recover, check the filesystem for consistency
+_scratch_mount
+umount $SCRATCH_MNT
+_check_scratch_fs
+
+# now clean up.
+_scratch_mount
+for d in $load_dir/*; do
+ rm -rf $d > /dev/null 2>&1 &
+done
+wait
+umount $SCRATCH_MNT
+_check_scratch_fs
+
+echo "No output is good. Failures are loud."
+
+status=0
+exit
diff --git a/tests/xfs/300.out b/tests/xfs/300.out
new file mode 100644
index 0000000..c763112
--- /dev/null
+++ b/tests/xfs/300.out
@@ -0,0 +1,2 @@
+QA output created by 300
+No output is good. Failures are loud.
diff --git a/tests/xfs/group b/tests/xfs/group
index 352a4c5..3f1702a 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -179,3 +179,4 @@
297 auto freeze
298 auto attr symlink quick
299 auto quota
+300 auto stress log metadata repair
--
1.8.3.2
_______________________________________________
xfs mailing list
xfs@oss.sgi.com
http://oss.sgi.com/mailman/listinfo/xfs
^ permalink raw reply related [flat|nested] 2+ messages in thread
* Re: [PATCH V2] xfstests: add fsstress/recovery test for XFS
2013-09-02 11:46 [PATCH V2] xfstests: add fsstress/recovery test for XFS Dave Chinner
@ 2013-10-30 4:02 ` Dave Chinner
0 siblings, 0 replies; 2+ messages in thread
From: Dave Chinner @ 2013-10-30 4:02 UTC (permalink / raw)
To: xfs
On Mon, Sep 02, 2013 at 09:46:31PM +1000, Dave Chinner wrote:
> From: Dave Chinner <dchinner@redhat.com>
>
> This has found several issues with recovery on CRC based
> filesystems. It is based on a test case for a dir3 assert failure
> provided by Michael L Semon.
>
> The test seems to pass now fine with or without CRCs enabled with
> all the kernel patches I've posted over the past day.
>
> Signed-off-by: Dave Chinner <dchinner@redhat.com>
Ping?
> ---
> tests/xfs/300 | 105 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
> tests/xfs/300.out | 2 ++
> tests/xfs/group | 1 +
> 3 files changed, 108 insertions(+)
> create mode 100644 tests/xfs/300
> create mode 100644 tests/xfs/300.out
>
> diff --git a/tests/xfs/300 b/tests/xfs/300
> new file mode 100644
> index 0000000..38ecd65
> --- /dev/null
> +++ b/tests/xfs/300
> @@ -0,0 +1,105 @@
> +#!/bin/bash
> +# FS QA Test No. xfs/300
> +#
> +# Basic log recovery stress test - do lots of stuff, shut down in the middle of
> +# it and check that recovery runs to completion and everything can be
> +# successfully removed afterwards..
> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2013 Red Hat, Inc. All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
> +#
> +#-----------------------------------------------------------------------
> +#
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1 # failure is the default!
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +_cleanup()
> +{
> + cd /
> + umount $SCRATCH_MNT 2>/dev/null
> + rm -f $tmp.*
> +}
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +# real QA test starts here
> +_supported_fs xfs
> +_supported_os Linux
> +
> +_require_scratch
> +
> +rm -f $seqres.full
> +
> +_scratch_mkfs > $seqres.full 2>&1
> +_scratch_mount
> +
> +SLEEP_TIME=$((30 * $TIME_FACTOR))
> +PROCS=$((2 * LOAD_FACTOR))
> +
> +load_dir=$SCRATCH_MNT/test
> +
> +# let this run for a while
> +$FSSTRESS_PROG -n10000000 -p $PROCS -d $load_dir >> $seqres.full 2>&1 &
> +sleep $SLEEP_TIME
> +killall -q $FSSTRESS_PROG
> +wait
> +sync
> +umount $SCRATCH_MNT
> +
> +# now mount again, run the load again, this time with a shutdown.
> +_scratch_mount
> +$XFS_FSR_PROG -v $load_dir >> $seqres.full 2>&1
> +$FSSTRESS_PROG -n10000000 -p $PROCS -d $load_dir >> $seqres.full 2>&1 &
> +sleep $SLEEP_TIME
> +sync
> +
> +# now shutdown and unmount
> +sleep 5
> +$here/src/godown $load_dir
> +killall -q $FSSTRESS_PROG
> +wait
> +
> +# for some reason fsstress processes manage to live on beyond the wait?
> +sleep 5
> +umount $SCRATCH_MNT
> +
> +# now recover, check the filesystem for consistency
> +_scratch_mount
> +umount $SCRATCH_MNT
> +_check_scratch_fs
> +
> +# now clean up.
> +_scratch_mount
> +for d in $load_dir/*; do
> + rm -rf $d > /dev/null 2>&1 &
> +done
> +wait
> +umount $SCRATCH_MNT
> +_check_scratch_fs
> +
> +echo "No output is good. Failures are loud."
> +
> +status=0
> +exit
> diff --git a/tests/xfs/300.out b/tests/xfs/300.out
> new file mode 100644
> index 0000000..c763112
> --- /dev/null
> +++ b/tests/xfs/300.out
> @@ -0,0 +1,2 @@
> +QA output created by 300
> +No output is good. Failures are loud.
> diff --git a/tests/xfs/group b/tests/xfs/group
> index 352a4c5..3f1702a 100644
> --- a/tests/xfs/group
> +++ b/tests/xfs/group
> @@ -179,3 +179,4 @@
> 297 auto freeze
> 298 auto attr symlink quick
> 299 auto quota
> +300 auto stress log metadata repair
> --
> 1.8.3.2
>
> _______________________________________________
> xfs mailing list
> xfs@oss.sgi.com
> http://oss.sgi.com/mailman/listinfo/xfs
>
--
Dave Chinner
david@fromorbit.com
_______________________________________________
xfs mailing list
xfs@oss.sgi.com
http://oss.sgi.com/mailman/listinfo/xfs
^ permalink raw reply [flat|nested] 2+ messages in thread
end of thread, other threads:[~2013-10-30 4:03 UTC | newest]
Thread overview: 2+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2013-09-02 11:46 [PATCH V2] xfstests: add fsstress/recovery test for XFS Dave Chinner
2013-10-30 4:02 ` Dave Chinner
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox